#!/bin/sh

AMIS=amis
LILFES=lilfes
PARSER=./parser/enju
MAKE=make
ECHO=echo
DIR=DATA

if [ $1 = "-n" ]; then
    is_exec="no"
    shift
else
    is_exec="yes"
fi
test_name=$1
shift

exec_command() {
    echo $1
    if [ $is_exec = "yes" ]; then
	eval $1
    fi
}

init_eval() {
    exec_command "$MAKE ${test_name}model"
    exec_command "$MAKE ${DIR}/22.derivbank"
    exec_command "$MAKE parser"
}

exec_eval() {
    sigma=$1
    exec_command "$AMIS devel/${test_name}model.conf --map-sigma $sigma -m ${DIR}/Enju-${test_name}.model -e ${DIR}/Enju-${test_name}.event.gz -o ${DIR}/Enju-${test_name}.output -l ${DIR}/Enju-${test_name}.log --reference on --reference-file ${DIR}/Enju-forest.ref" &&
    exec_command "$PARSER -t cat -g grammar/grammar -f grammar/${test_name}model -l devel/evalpas -e 'eval_parse_file(\"${DIR}/22.derivbank\", \"eval-${test_name}-22-map$sigma\")'"
}

if init_eval; then
    for sigma in $* ; do
	exec_eval $sigma
    done
fi

