/**********************************************************************
 *
 *  Copyright (c) 2005, Tsujii Laboratory, The University of Tokyo.
 *  All rights reserved.
 *
 *  @file FMGrammar.cc
 *  @version Time-stamp: <2005-06-21 19:07:00 yusuke>
 *  Grammar for making feature forest
 *
 **********************************************************************/

#include "FMGrammar.h"

namespace mayz {

  using namespace std;
  using namespace lilfes;
  using namespace up;

  bool FMGrammar::init( machine* m ) {
    mach = m;
    if ( ! Grammar::init( m ) ) return false;
    fm_derivation_to_word_lattice = prepare_proc( module::UserModule(), "fm_derivation_to_word_lattice", 2 );
    if ( ! fm_derivation_to_word_lattice ) {
      RUNERR( "predicate not defined: 'fom_derivation_to_word_lattice/2'" );
      return false;
    }
    fm_lexical_entry = prepare_proc( module::UserModule(), "fm_lexical_entry", 2 );
    if ( ! fm_lexical_entry ) {
      RUNERR( "predicate not defined: 'fm_lexical_entry/2'" );
      return false;
    }
    return true;
  }

}

