/**********************************************************************
 *
 *  Copyright (c) 2005, Tsujii Laboratory, The University of Tokyo.
 *  All rights reserved.
 *
 *  @file FMGrammar.h
 *  @version Time-stamp: <2005-06-21 19:06:56 yusuke>
 *  Grammar for making feature forest
 *
 **********************************************************************/

#ifndef MAYZ_FM_GRAMMAR_H

#define MAYZ_FM_GRAMMAR_H

#include "config_mayz.h"
#include "Grammar.h"
#include <liblilfes/utility.h>

namespace mayz {

  class FMGrammar : public up::Grammar {
  private:
    lilfes::machine* mach;
    lilfes::procedure* fm_derivation_to_word_lattice;
    lilfes::procedure* fm_lexical_entry;

  public:
    FMGrammar() : up::Grammar() {
    }
    virtual ~FMGrammar() {
    }

    bool init( lilfes::machine* m );

    bool sentence2WordLattice( lilfes::FSP derivation, lilfes::FSP wordlattice ) {
      std::vector< lilfes::FSP > args( 2 );
      args[ 0 ] = derivation;
      args[ 1 ] = wordlattice;
      return lilfes::call_proc( *mach, fm_derivation_to_word_lattice, args );
    }
    bool lexicalEntry( lilfes::FSP lexid, lilfes::FSP sign ) {
      std::vector< lilfes::FSP > args( 2 );
      args[ 0 ] = lexid;
      args[ 1 ] = sign;
      return lilfes::call_proc( *mach, fm_lexical_entry, args );
    }
  };

}

#endif // MAYZ_FM_GRAMMAR_H
