/*
 * $Id: Fsp.h,v 1.3 2005/06/21 10:17:12 yusuke Exp $
 *
 *  Copyright (c) 2005, Tsujii Laboratory, The University of Tokyo.
 *  All rights reserved.
 *
 */

#ifndef __Fsp_h
#define __Fsp_h

#include <liblilfes/machine.h>
#include <liblilfes/structur.h>
#include <liblilfes/ftype.h>
#include "Edge.h"
#include "Extent.h"
//#include "Fom.h"

namespace up {

    class FspMaker {
    private:
	lilfes::machine* mach;

	// type and feature for Link
        const lilfes::type *terminal;
        const lilfes::type *nonterminal_unary;
        const lilfes::type *nonterminal_binary;
    
        const lilfes::feature *f_sign_plus;
//         const lilfes::feature *f_cell;
//         const lilfes::feature *f_leaf_cell;
        const lilfes::feature *f_lex_name;
//         const lilfes::feature *f_leaf_id;
        const lilfes::feature *f_applied_schema;
        const lilfes::feature *f_l_dtr;
        const lilfes::feature *f_r_dtr;
        const lilfes::feature *f_u_dtr;
//         const lilfes::feature *f_l_cell;
//         const lilfes::feature *f_r_cell;
//         const lilfes::feature *f_u_cell;

	// type and feature for extent
        const lilfes::type* extent;
        const lilfes::type* extent_bracket;
        const lilfes::type* extent_word;

        const lilfes::feature *f_left_position;
        const lilfes::feature *f_right_position;
        const lilfes::feature *f_word;

//         const lilfes::type *link_fom;
//         const lilfes::feature *f_link_fom;
//         const lilfes::feature *f_sign_reduction;

    public:
	FspMaker() {}
	~FspMaker() {}
	bool init(lilfes::machine* m);
	lilfes::FSP makeFSP(Edge*);
	lilfes::FSP makeFSP(Link*);
	lilfes::FSP makeFSP(LinkBinary*);
	lilfes::FSP makeFSP(LinkUnary*);
	lilfes::FSP makeFSP(LinkTerminal*);
	lilfes::FSP makeFSP(Extent*);
//         lilfes::FSP makeFSP(Link*, FomManager*);
	Extent* newExtent(lilfes::FSP);
    };

} // end of namespace up

#endif // __Fsp_h

/*
 * $Log: Fsp.h,v $
 * Revision 1.3  2005/06/21 10:17:12  yusuke
 *
 * copyright 񤭤ޤ
 *
 * Revision 1.2  2005/06/16 07:25:36  yusuke
 *
 * integrate-up 硥
 * version 2.0
 *
 * Revision 1.1.2.5  2005/06/06 14:56:05  yusuke
 *
 * get_parser_mode, get_parse_status ʳϼ
 *
 * Revision 1.1.2.4  2005/06/06 14:11:23  yusuke
 *
 * ParserCky Ϥۤư褦ˤʤޤ
 *
 * Revision 1.1.2.3  2005/06/06 09:00:18  ninomi
 * Fsp.ccextentleft_pos, right_posleft_position, right_positionѹ
 * ޤ
 *
 * Revision 1.1.2.2  2005/06/05 14:10:48  ninomi
 * ѥ뤬Ȥ褦ˤʤޤ
 *
 * Revision 1.1.2.1  2005/06/05 10:12:18  ninomi
 * upmayz/srcβ˰ܤϤޤ
 *
 * Revision 1.3  2005/02/26 12:18:12  yusuke
 *
 * edge_info γΨȡfom_equivalent_reduction 裳¸ơ
 * edge_info_fom 褦ˤ
 *
 * Revision 1.2  2004/11/16 09:13:54  ninomi
 * Artistic LicenseƬˤĤޤ
 *
 * Revision 1.1  2004/06/30 07:50:09  ninomi
 * up 0.2release versionǤ
 *
 */
