/**********************************************************************
 *
 *  Copyright (c) 2005, Tsujii Laboratory, The University of Tokyo.
 *  All rights reserved.
 *
 *  @file Lexicon.cc
 *  @version Time-stamp: <2005-06-21 19:05:59 yusuke>
 *  Implementation of a lexicon (mappings from words to templates)
 *
 **********************************************************************/

#include "Lexicon.h"
#include <liblilfes/builtin.h>

namespace mayz {

  using namespace lilfes;
  using namespace std;

  bool Lexicon::add( FSP word, const LexTemplate& name ) {
    //if ( ! incCount( word ) ) return false;
    vector< lilfes::FSP > lex_list;
    if ( lexicon_db.find( word, lex_list ) ) {
      for ( vector< lilfes::FSP >::const_iterator it = lex_list.begin();
            it != lex_list.end();
            ++it ) {
        if ( builtin::equivalent( *mach, *it, name ) ) return true;
      }
    }
    lex_list.push_back( name );
    return lexicon_db.insert( word, lex_list );
  }

  bool Lexicon::load( const string& lexfile ) {
    return lexicon_db.load( lexfile );
  }
  bool Lexicon::save( const string& lexfile ) {
    return lexicon_db.save( lexfile );
  }

}

