/*
 * $Id: Qc.cc,v 1.3 2005/06/21 10:17:12 yusuke Exp $
 *
 *  Copyright (c) 2005, Tsujii Laboratory, The University of Tokyo.
 *  All rights reserved.
 *
 */

#include "Qc.h"

namespace up {
    using namespace lilfes;

    void QcManager::clear() {
        P2("QcManager::clear");
        std::vector<std::vector<std::pair<Fs*, qc::QCA*> > >::iterator
            it = idschema_qca.begin(), last = idschema_qca.end();
        for(; it != last ; ++it) {
            std::vector<std::pair<Fs*, qc::QCA*> >::iterator it2 = it->begin(), last2 = it->end();
            for(; it2 != last2 ; ++it2) {
                delete it2->first;
            }
        }
	edge_qca.clear();
	idschema_qca.clear();
	qcam->Clear();
    }
    bool QcManager::quickCheck(qc::QCA* x, qc::QCA* y) {
        P2("QcManager::quickCheck");
	return qcm->QuickCheck(x, y);
    }
    void QcManager::makeQca(eserial esn, Fs* x) {
        P2("QcManager::makeQca");
	
        if(esn >= edge_qca.size()) {
            edge_qca.resize(esn+1, 0);
            idschema_qca.resize(esn+1);
        }
        IPTrailStack iptrail(mach);
        FSP name(mach); FSP left(mach, x); FSP right(mach); FSP mother(mach); FSP dcp(mach);
            
        edge_qca[esn] = qcam->MakeQCA(left);

        bool loop = grammar->idSchemaBinary(name, left, right, mother, dcp);
        for(; loop ; loop = mach->NextAnswer()) {
            idschema_qca[esn].push_back(std::make_pair(name.Serialize(),
                                                       qcam->MakeQCA(right)));
        }
    }
}

/*
 * $Log: Qc.cc,v $
 * Revision 1.3  2005/06/21 10:17:12  yusuke
 *
 * copyright 񤭤ޤ
 *
 * Revision 1.2  2005/06/16 07:25:36  yusuke
 *
 * integrate-up 硥
 * version 2.0
 *
 * Revision 1.1.2.6  2005/06/08 05:59:42  ninomi
 * P2ץեĤʤޤ
 *
 * Revision 1.1.2.5  2005/06/06 08:53:41  ninomi
 * IPTrailStackطľޤlilfespredicate callʤޤ
 * quick checkidҤˤΤnameǤҤ褦ˤޤ
 *
 * Revision 1.1.2.4  2005/06/05 14:10:48  ninomi
 * ѥ뤬Ȥ褦ˤʤޤ
 *
 * Revision 1.1.2.3  2005/06/05 13:14:21  ninomi
 * Ȥꤢ񴹤ޤǤФäϤ줫
 *
 * Revision 1.1.2.2  2005/06/05 12:19:49  ninomi
 * upmayzβˤĤޤ
 *
 * Revision 1.1.2.1  2005/06/05 10:12:19  ninomi
 * upmayz/srcβ˰ܤϤޤ
 *
 * Revision 1.5  2005/06/03 15:31:20  ninomi
 * ParserCkyQcβɤ򤷤ޤ
 *
 * Revision 1.4  2004/11/16 09:14:07  ninomi
 * Artistic LicenseƬˤĤޤ
 *
 * Revision 1.3  2004/07/02 03:25:49  ninomi
 * QcFomΣĤΤơ
 * Parser->ParserBasic->ParserCky->ParserCkyQc->ParserFom褦ˤޤQuickCheckenableQuickCheck, disableQuickCheckOn/OffǤޤ
 *
 * Revision 1.2  2004/06/30 13:38:23  ninomi
 * ʸĹsetLimitWordsǡ票åsetLimitEdgesǥѡǤʤ
 * ФĤǤѹǤ褦ˤޤ
 *
 * Revision 1.1  2004/06/30 07:50:29  ninomi
 * up 0.2release versionǤ
 *
 */
