/**********************************************************************
 *
 *  Copyright (c) 2005, Tsujii Laboratory, The University of Tokyo.
 *  All rights reserved.
 *
 *  @file arraytest.cc
 *  @version Time-stamp: <2005-06-21 19:05:30 yusuke>
 *  Test program for FSArray
 *
 **********************************************************************/

#include "FSArray.h"
#include <liblilfes/lilfes.h>
#include <vector>
#include <iostream>

using namespace mayz;
using namespace lilfes;
using namespace std;

int main( void ) {
  Initializer::PerformAll();

  machine mach;
  FSArray< int, FSP > array( &mach );

  cerr << "start" << endl;
  cerr << "insert (5,\"hogehoge\")" << endl;
  if ( array.insert( 5, FSP( mach, "hogehoge" ) ) ) {
    cerr << "  success." << endl;
  } else {
    cerr << "  failure." << endl;
  }
  cerr << "insert (6,\"poepoe\")" << endl;
  if ( array.insert( 6, FSP( mach, "poepoe" ) ) ) {
    cerr << "  success." << endl;
  } else {
    cerr << "  failure." << endl;
  }
  cerr << "find (5, X)" << endl;
  FSP x;
  if ( array.find( 5, x ) ) {
    cerr << "  x = " << x.DisplayAVM();
  } else {
    cerr << "  failure." << endl;
  }
  cerr << "saving... ";
  array.save( "hoge.ldbm" );
  cerr << "done." << endl;

  Terminator::PerformAll();
};

